using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;

namespace ThumbViewer
{
    public partial class OptionsForm : Form
    {
        public OptionsForm()
        {
            InitializeComponent();
        }

        private void OnLoad(object sender, EventArgs e)
        {
            RegistryKey rkRoot = Registry.ClassesRoot;

            RegistryKey rkThumbs = rkRoot.OpenSubKey("Thumbs.db");
            if (rkThumbs != null)
                this.checkAssoc.Checked = true;

            RegistryKey rkUser = Registry.CurrentUser;
            RegistryKey rkOptions = rkUser.OpenSubKey("Software\\ITSoftware\\ThumbViewer");
            if(rkOptions != null)
            {
                Int32 nTopMost = (Int32)rkOptions.GetValue("TopMost", 1);
                if(nTopMost>0) this.checkOnTop.Checked = true;

                Int32 nOpenFile = (Int32)rkOptions.GetValue("OpenFile",1);
                if(nOpenFile>0) this.checkOpen.Checked = true;
            }
        }

        private void OnOK(object sender, EventArgs e)
        {
            RegistryKey rkRoot = Registry.ClassesRoot;
            RegistryKey rkFileType = rkRoot.OpenSubKey(".db", true);
            
            if (this.checkAssoc.Checked == true)
            {
                if (rkFileType == null)
                {
                    RegistryKey rkNew = rkRoot.CreateSubKey(".db");
                    rkNew.SetValue("", "Thumbs.db");
                }
                else
                {
                    rkFileType.SetValue("", "Thumbs.db");
                }

                RegistryKey rkInfo = rkRoot.CreateSubKey("Thumbs.db");
                if (rkInfo != null)
                {
                    String strPath = Application.ExecutablePath;
                    
                    // Set the default value to the file type description
                    rkInfo.SetValue("", "Thumbnail Database File");

                    RegistryKey rkShell = rkInfo.CreateSubKey("shell");
                    if (rkShell != null)
                    {
                        RegistryKey rkOpen = rkShell.CreateSubKey("open");
                        if (rkOpen != null)
                        {
                            rkOpen.SetValue("", "&Open Document");
                            RegistryKey rkCommand = rkOpen.CreateSubKey("command");
                            if (rkCommand != null)
                                rkCommand.SetValue("", strPath+" %1");
                        }
                    }
                    
                    RegistryKey rkIcon = rkInfo.CreateSubKey("DefaultIcon");
                    if (rkIcon != null)
                        rkIcon.SetValue("", strPath + ",0");
                }
            }
            else
            {
                if (rkFileType == null)
                {
                    RegistryKey rkNew = rkRoot.CreateSubKey(".db");
                    rkNew.SetValue("", "dbfile");
                }
                else
                {
                    rkFileType.SetValue("", "dbfile");
                }

                RegistryKey rkThumbs = rkRoot.OpenSubKey("Thumbs.db", true);
                if (rkThumbs != null)
                    rkRoot.DeleteSubKeyTree("Thumbs.db");
            }
            
            RegistryKey rkUser = Registry.CurrentUser;
            RegistryKey rkOptions = rkUser.OpenSubKey("Software\\ITSoftware\\ThumbViewer", true);
            if (rkOptions == null) rkOptions = rkUser.CreateSubKey("Software\\ITSoftware\\ThumbViewer");
            if (rkOptions != null)
            {
                rkOptions.SetValue("TopMost", (bool)this.checkOnTop.Checked, RegistryValueKind.DWord);
                rkOptions.SetValue("OpenFile", (bool)this.checkOpen.Checked, RegistryValueKind.DWord);
            }
        }
    }
}